<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>Z:/Project/development/PSCIP/driver/test_prog.c Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.7.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<h1>Z:/Project/development/PSCIP/driver/test_prog.c</h1><a href="test__prog_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*************************************************************************************</span>
<a name="l00002"></a>00002 <span class="comment">interpretation by Maciek</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">the executed test program peforms the action/command defined by providing appropratate argument,</span>
<a name="l00005"></a>00005 <span class="comment">command is performed on a particular channel of choosen device (minor number) on a VME specified </span>
<a name="l00006"></a>00006 <span class="comment">by the address</span>
<a name="l00007"></a>00007 <span class="comment"></span>
<a name="l00008"></a>00008 <span class="comment">everything is defined by the arguments inputed when invoking program</span>
<a name="l00009"></a>00009 <span class="comment">*************************************************************************************/</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">/*</span>
<a name="l00012"></a>00012 <span class="comment"> * test.c: use async notification to read stdin</span>
<a name="l00013"></a>00013 <span class="comment"> */</span>
<a name="l00014"></a>00014 <span class="preprocessor">#include &lt;sys/types.h&gt;</span>
<a name="l00015"></a>00015 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00016"></a>00016 <span class="preprocessor">#include &lt;sys/time.h&gt;</span>
<a name="l00017"></a>00017 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00018"></a>00018 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00019"></a>00019 <span class="preprocessor">#include &lt;unistd.h&gt;</span>
<a name="l00020"></a>00020 <span class="preprocessor">#include &lt;signal.h&gt;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;fcntl.h&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;sys/ioctl.h&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include "<a class="code" href="pscip_8h.html" title="Header file used in the driver and device server.">pscip.h</a>"</span>
<a name="l00024"></a>00024 
<a name="l00025"></a><a class="code" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">00025</a> <a class="code" href="structpscip__t.html">pscip_t</a> <a class="code" href="test_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>;
<a name="l00026"></a>00026 <span class="comment">// typedef struct {</span>
<a name="l00027"></a>00027 <span class="comment">//   unsigned  int  chan;   /* channel 0/1 */</span>
<a name="l00028"></a>00028 <span class="comment">//   unsigned  char  stat,    /* status register */ </span>
<a name="l00029"></a>00029 <span class="comment">//      address;   /* address register */</span>
<a name="l00030"></a>00030 <span class="comment">//     int  data;       </span>
<a name="l00031"></a>00031 <span class="comment">// } pscip_t; </span>
<a name="l00032"></a>00032 <span class="comment">/********************************************************************************</span>
<a name="l00033"></a>00033 <span class="comment">how to start the program:</span>
<a name="l00034"></a>00034 <span class="comment">$ executable &lt;devidx(0,1..20)&gt; &lt;chan(0,1)&gt; &lt;address&gt; &lt;r/w/a/t&gt; &lt;data type(i,x,f)&gt; &lt;value(only write)&gt; \n",argv[0]);</span>
<a name="l00035"></a>00035 <span class="comment"></span>
<a name="l00036"></a>00036 <span class="comment">parameter:</span>
<a name="l00037"></a>00037 <span class="comment">- &lt;devidx(0,1..20)&gt; - device index</span>
<a name="l00038"></a>00038 <span class="comment">- &lt;chan(0,1)&gt;   - chanal</span>
<a name="l00039"></a>00039 <span class="comment">- &lt;address&gt;   - adress - address passed by fiber to the power supply, not vme addres!!!!!!!!!!</span>
<a name="l00040"></a>00040 <span class="comment">- &lt;r/w/a/t&gt;  - read/write/write wave/read wave</span>
<a name="l00041"></a>00041 <span class="comment">- &lt;data type(i,x,f)&gt; - data type??: integer, hex, float</span>
<a name="l00042"></a>00042 <span class="comment">- &lt;value(only write)&gt; - value, if writing</span>
<a name="l00043"></a>00043 <span class="comment">********************************************************************************/</span>
<a name="l00044"></a><a class="code" href="test__prog_8c.html#ba5fa490390565dff7f19d1fd8a868d8">00044</a> <span class="keyword">static</span> <span class="keywordtype">char</span> <a class="code" href="test__prog_8c.html#ba5fa490390565dff7f19d1fd8a868d8">psc_errmsg</a>[][<a class="code" href="pscip_8h.html#d665b2c4a0bd94221563aef3f1ac61a2">PSCIP_SIZE_MSG</a>] = {
<a name="l00045"></a>00045  <span class="stringliteral">"Echo value doesn't match"</span>, 
<a name="l00046"></a>00046  <span class="stringliteral">"Remote control disabled"</span>,
<a name="l00047"></a>00047  <span class="stringliteral">"Generic reading error"</span>, 
<a name="l00048"></a>00048  <span class="stringliteral">"Data timeout"</span>,
<a name="l00049"></a>00049  <span class="stringliteral">"Input buffer full"</span>,
<a name="l00050"></a>00050  <span class="stringliteral">"Dsp stopped"</span>,
<a name="l00051"></a>00051  <span class="stringliteral">"Link is down"</span>,
<a name="l00052"></a>00052  <span class="stringliteral">"Transmission error"</span>, 
<a name="l00053"></a>00053  <span class="stringliteral">"Parameter error"</span>,
<a name="l00054"></a>00054  <span class="stringliteral">"VME bus error"</span> 
<a name="l00055"></a>00055 };
<a name="l00056"></a>00056 <span class="comment">/*</span>
<a name="l00057"></a>00057 <span class="comment"> * pscip_get_errmsg()</span>
<a name="l00058"></a>00058 <span class="comment"> * Convert error code in a error message</span>
<a name="l00059"></a>00059 <span class="comment"> */</span>
<a name="l00060"></a>00060  
<a name="l00061"></a>00061 
<a name="l00062"></a><a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">00062</a>  <span class="keyword">static</span> <span class="keywordtype">char</span> *<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(<span class="keywordtype">int</span> err)
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064  <span class="keywordtype">int</span> offset = err - <a class="code" href="pscip_8h.html#f1c216310d1c8a97199c376c50577ca5">PSCIP_IOCTL_MAGIC</a>;
<a name="l00065"></a>00065  <span class="keywordflow">if</span> ((offset &gt;= 0) &amp;&amp; (offset &lt; (<span class="keyword">sizeof</span>(<a class="code" href="test__prog_8c.html#ba5fa490390565dff7f19d1fd8a868d8">psc_errmsg</a>)/<a class="code" href="pscip_8h.html#d665b2c4a0bd94221563aef3f1ac61a2">PSCIP_SIZE_MSG</a>))) 
<a name="l00066"></a>00066   <span class="keywordflow">return</span> <a class="code" href="test__prog_8c.html#ba5fa490390565dff7f19d1fd8a868d8">psc_errmsg</a>[offset];
<a name="l00067"></a>00067    
<a name="l00068"></a>00068  <span class="keywordflow">return</span> <span class="stringliteral">"Linux error message"</span>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070  <span class="keywordflow">return</span> 0;  <span class="comment">//added for 2.6 - temporary to avoid warnings </span>
<a name="l00071"></a>00071 } 
<a name="l00072"></a>00072 <span class="comment">/* pscip_get_errmsg() */</span>
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="test__prog_8c.html#0ddf1224851353fc92bfbff6f499fa97">00074</a> <span class="keywordtype">int</span> <a class="code" href="test_8c.html#0ddf1224851353fc92bfbff6f499fa97">main</a>(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> *argv[])
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076  <span class="keywordtype">int</span> fd,i;
<a name="l00077"></a>00077  <span class="keywordtype">int</span> err,tmp;
<a name="l00078"></a>00078  <span class="keywordtype">char</span> devname[20];
<a name="l00079"></a>00079  <span class="keywordtype">float</span> ftmp;
<a name="l00080"></a>00080  <span class="keywordtype">int</span> cnt = 0;
<a name="l00081"></a>00081  <span class="keywordtype">char</span> command=0;
<a name="l00082"></a>00082  <span class="keywordtype">char</span> addr[10];
<a name="l00083"></a>00083  <span class="keywordtype">char</span> data[10];
<a name="l00084"></a>00084  <span class="keywordtype">char</span> cformat[10];
<a name="l00085"></a>00085  <span class="keywordtype">char</span> format=0;
<a name="l00086"></a>00086  <span class="keywordtype">char</span> cos=0;
<a name="l00087"></a>00087  <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> pciaddr=0;
<a name="l00088"></a>00088  
<a name="l00089"></a>00089  
<a name="l00090"></a>00090  <span class="keywordflow">if</span> ((argc != 6) &amp;&amp; (argc != 3)) 
<a name="l00091"></a>00091  {
<a name="l00092"></a>00092 <span class="comment">//  printf("Usage: %s &lt;devidx(0,1..20)&gt; &lt;chan(0,1)&gt; &lt;address&gt; &lt;r/w/a/t&gt; &lt;data type(i,x,f)&gt; &lt;value(only write)&gt; \n",argv[0]);</span>
<a name="l00093"></a>00093   printf(<span class="stringliteral">"Usage: %s &lt;devidx(0,1..20)&gt; &lt;chan(0,1)&gt;  \n"</span>,argv[0]);
<a name="l00094"></a>00094   printf(<span class="stringliteral">"NOTE: At this stage of development the program should be opened: %s 0 0  \n"</span>,argv[0]);
<a name="l00095"></a>00095   <span class="keywordflow">return</span> 0;
<a name="l00096"></a>00096  } 
<a name="l00097"></a>00097  sprintf(devname,<span class="stringliteral">"/dev/pscip%d"</span>,atoi(argv[1]));
<a name="l00098"></a>00098       
<a name="l00099"></a>00099  <span class="keywordflow">if</span> ((fd = open(devname, O_RDWR)) &lt; 0) 
<a name="l00100"></a>00100  {
<a name="l00101"></a>00101   printf(<span class="stringliteral">"Cannot open /dev/pscip\n"</span>);
<a name="l00102"></a>00102   <span class="keywordflow">return</span> 0;
<a name="l00103"></a>00103  }  
<a name="l00104"></a>00104  <span class="keywordflow">else</span>
<a name="l00105"></a>00105   printf(<span class="stringliteral">"%s has been openned sucessfully\n"</span>, devname);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107  <span class="keywordflow">while</span>(command != <span class="charliteral">'q'</span>)
<a name="l00108"></a>00108  {
<a name="l00109"></a>00109   printf(<span class="stringliteral">"Please, give the command: \n r\t - for read\n w \t - for read \n a \t - for write wave \n t \t - for read wave \n v \t - read given IP address \n c \t -write given IP address with given data \n s \t - for reset IP \n p - for clearing ERROR counter \n x \t - for current setting\n y \t - for reading PCI address &amp; all regs \n n \t - for turning on the device\n d \t - dump all the IP regs\n f \t - for off the device \n q \t to EXIT\n"</span>);
<a name="l00110"></a>00110   
<a name="l00111"></a>00111   scanf(<span class="stringliteral">"%c"</span>,&amp;command);
<a name="l00112"></a>00112   cos=getchar();
<a name="l00113"></a>00113   <span class="keywordflow">if</span>(command == <span class="charliteral">'q'</span>)
<a name="l00114"></a>00114    <span class="keywordflow">return</span> 0;
<a name="l00115"></a>00115   <span class="keywordflow">if</span>(command != <span class="charliteral">'s'</span>  &amp;&amp; command != <span class="charliteral">'y'</span> &amp;&amp; command != <span class="charliteral">'n'</span> &amp;&amp; command != <span class="charliteral">'f'</span> &amp;&amp; command != <span class="charliteral">'1'</span> &amp;&amp; command != <span class="charliteral">'2'</span> &amp;&amp; command != <span class="charliteral">'3'</span> &amp;&amp; command != <span class="charliteral">'d'</span> &amp;&amp; command != <span class="charliteral">'p'</span>)
<a name="l00116"></a>00116   {
<a name="l00117"></a>00117    printf(<span class="stringliteral">"Please, give the address of Power Supply\n"</span>); 
<a name="l00118"></a>00118   <span class="comment">//gets(addr);</span>
<a name="l00119"></a>00119   <span class="comment">//cos = getchar();</span>
<a name="l00120"></a>00120  
<a name="l00121"></a>00121    scanf(<span class="stringliteral">"%s"</span>, addr);
<a name="l00122"></a>00122    cos=getchar();
<a name="l00123"></a>00123   }
<a name="l00124"></a>00124   <span class="keywordflow">if</span> (command == <span class="charliteral">'n'</span>)
<a name="l00125"></a>00125   {
<a name="l00126"></a>00126    printf(<span class="stringliteral">"Turning on the device ............. \n"</span>);
<a name="l00127"></a>00127    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);
<a name="l00128"></a>00128    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0xc0; <span class="comment">/* reading status register */</span> 
<a name="l00129"></a>00129    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x3c;
<a name="l00130"></a>00130    val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = 0x00000001;
<a name="l00131"></a>00131    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#145abb0528d0562f2d3e9180d2d8bdd7">PSCIP_WRITE</a>, &amp;val)))
<a name="l00132"></a>00132    {
<a name="l00133"></a>00133     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00134"></a>00134     <span class="comment">//return 0;</span>
<a name="l00135"></a>00135     
<a name="l00136"></a>00136    }
<a name="l00137"></a>00137    <span class="keywordflow">else</span>
<a name="l00138"></a>00138     printf(<span class="stringliteral">"The device should be on - the LED should be green, if it's not..... it's not good\n"</span>);
<a name="l00139"></a>00139    
<a name="l00140"></a>00140   }<span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'d'</span>)
<a name="l00141"></a>00141   {
<a name="l00142"></a>00142    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]); 
<a name="l00143"></a>00143    printf(<span class="stringliteral">"Choosen chanal:  %d\n"</span>,val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> );
<a name="l00144"></a>00144    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#98ab0b3a0501e0ad2b1e7377b8ba621d">PSCIP_DUMPFPGAREGS</a>, &amp;val)))
<a name="l00145"></a>00145    {
<a name="l00146"></a>00146     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00147"></a>00147     <span class="comment">//return 0;</span>
<a name="l00148"></a>00148     
<a name="l00149"></a>00149    }
<a name="l00150"></a>00150     
<a name="l00151"></a>00151   }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="comment">//read register 0x24 in PSC</span>
<a name="l00154"></a>00154   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'1'</span>)
<a name="l00155"></a>00155   {
<a name="l00156"></a>00156    printf(<span class="stringliteral">"reading address 0x24 ............. \n"</span>);
<a name="l00157"></a>00157    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);
<a name="l00158"></a>00158    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x40; <span class="comment">/* reading status register */</span> 
<a name="l00159"></a>00159    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x24;
<a name="l00160"></a>00160    val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = 0;
<a name="l00161"></a>00161    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#1ad87f3dd3daf9ceac34bc7c040fd488">PSCIP_READ</a>, &amp;val)))
<a name="l00162"></a>00162    {
<a name="l00163"></a>00163     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00164"></a>00164     <span class="comment">//return 0;</span>
<a name="l00165"></a>00165     
<a name="l00166"></a>00166    }
<a name="l00167"></a>00167    <span class="keywordflow">else</span>
<a name="l00168"></a>00168     printf(<span class="stringliteral">"The device should be off - the LED should go off \n"</span>);
<a name="l00169"></a>00169    printf(<span class="stringliteral">"the value of the register with address 0x%x is: %d (0x%x)\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>, val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00170"></a>00170   }
<a name="l00171"></a>00171   <span class="comment">//read reg 0x3b in PSC</span>
<a name="l00172"></a>00172   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'2'</span>)
<a name="l00173"></a>00173   {
<a name="l00174"></a>00174    printf(<span class="stringliteral">"reading address 0x3b ............. \n"</span>);
<a name="l00175"></a>00175    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);
<a name="l00176"></a>00176    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x40; <span class="comment">/* reading status register */</span> 
<a name="l00177"></a>00177    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x3b;
<a name="l00178"></a>00178    val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = 0;
<a name="l00179"></a>00179    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#1ad87f3dd3daf9ceac34bc7c040fd488">PSCIP_READ</a>, &amp;val)))
<a name="l00180"></a>00180    {
<a name="l00181"></a>00181     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00182"></a>00182     <span class="comment">//return 0;</span>
<a name="l00183"></a>00183     
<a name="l00184"></a>00184    }
<a name="l00185"></a>00185    <span class="keywordflow">else</span>
<a name="l00186"></a>00186     printf(<span class="stringliteral">"The device should be off - the LED should go off \n"</span>);
<a name="l00187"></a>00187    printf(<span class="stringliteral">"the value of the register with address 0x%x is: %d (0x%x)\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>, val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00188"></a>00188   }
<a name="l00189"></a>00189   <span class="comment">//read register 0x3c in PSC</span>
<a name="l00190"></a>00190   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'3'</span>)
<a name="l00191"></a>00191   {
<a name="l00192"></a>00192    printf(<span class="stringliteral">"reading address 0x3c............. \n"</span>);
<a name="l00193"></a>00193    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);
<a name="l00194"></a>00194    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x40; <span class="comment">/* reading status register */</span> 
<a name="l00195"></a>00195    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x3c;
<a name="l00196"></a>00196    val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = 0;
<a name="l00197"></a>00197    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#1ad87f3dd3daf9ceac34bc7c040fd488">PSCIP_READ</a>, &amp;val)))
<a name="l00198"></a>00198    {
<a name="l00199"></a>00199     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00200"></a>00200     <span class="comment">//return 0;</span>
<a name="l00201"></a>00201     
<a name="l00202"></a>00202    }
<a name="l00203"></a>00203    <span class="keywordflow">else</span>
<a name="l00204"></a>00204     printf(<span class="stringliteral">"The device should be off - the LED should go off \n"</span>);
<a name="l00205"></a>00205    printf(<span class="stringliteral">"the value of the register with address 0x%x is: %d (0x%x) \n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>, val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00206"></a>00206   }
<a name="l00207"></a>00207   <span class="comment">//turn OFF fast converter</span>
<a name="l00208"></a>00208   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'f'</span>)
<a name="l00209"></a>00209   {
<a name="l00210"></a>00210    printf(<span class="stringliteral">"Turning off the device ............. \n"</span>);
<a name="l00211"></a>00211    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);
<a name="l00212"></a>00212    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0xc0; <span class="comment">/* reading status register */</span> 
<a name="l00213"></a>00213    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x3c;
<a name="l00214"></a>00214    val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = 0;
<a name="l00215"></a>00215    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#145abb0528d0562f2d3e9180d2d8bdd7">PSCIP_WRITE</a>, &amp;val)))
<a name="l00216"></a>00216    {
<a name="l00217"></a>00217     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00218"></a>00218     <span class="comment">//return 0;</span>
<a name="l00219"></a>00219     
<a name="l00220"></a>00220    }
<a name="l00221"></a>00221    <span class="keywordflow">else</span>
<a name="l00222"></a>00222     printf(<span class="stringliteral">"The device should be off - the LED should go off \n"</span>);
<a name="l00223"></a>00223    
<a name="l00224"></a>00224   }
<a name="l00225"></a>00225   <span class="comment">//read data from PSC</span>
<a name="l00226"></a>00226   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'r'</span>)   <span class="comment">//read</span>
<a name="l00227"></a>00227   {
<a name="l00228"></a>00228    printf(<span class="stringliteral">"Reading ............. \n"</span>);
<a name="l00229"></a>00229    printf(<span class="stringliteral">"Please, give the data format: \n i\t - for integer\n x \t - for hex \n f \t -for float \n"</span>);
<a name="l00230"></a>00230    <span class="comment">//format = getchar();</span>
<a name="l00231"></a>00231    scanf(<span class="stringliteral">"%c"</span>,&amp;format);
<a name="l00232"></a>00232    cos=getchar();
<a name="l00233"></a>00233    <span class="keywordflow">while</span>(1) 
<a name="l00234"></a>00234    {
<a name="l00235"></a>00235     
<a name="l00236"></a>00236     val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);
<a name="l00237"></a>00237     val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x40; <span class="comment">/* reading status register */</span> 
<a name="l00238"></a>00238     sscanf(addr, <span class="stringliteral">"%2x"</span>, &amp;tmp);
<a name="l00239"></a>00239     printf(<span class="stringliteral">"given addres: %3x\n"</span>, tmp);
<a name="l00240"></a>00240     val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = tmp;
<a name="l00241"></a>00241     <span class="comment">//val.address = 0x9C;</span>
<a name="l00242"></a>00242    
<a name="l00243"></a>00243     <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#1ad87f3dd3daf9ceac34bc7c040fd488">PSCIP_READ</a>, &amp;val)))
<a name="l00244"></a>00244     {
<a name="l00245"></a>00245      printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00246"></a>00246      <span class="comment">//return 0;</span>
<a name="l00247"></a>00247      <span class="keywordflow">break</span>;
<a name="l00248"></a>00248     } 
<a name="l00249"></a>00249     <span class="keywordflow">else</span> 
<a name="l00250"></a>00250     {
<a name="l00251"></a>00251      <span class="keywordflow">if</span> (format == <span class="charliteral">'i'</span>) {
<a name="l00252"></a>00252       printf(<span class="stringliteral">"value addr(0x%x) = %d\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00253"></a>00253      }
<a name="l00254"></a>00254      <span class="keywordflow">else</span> <span class="keywordflow">if</span> (format == <span class="charliteral">'x'</span>) { 
<a name="l00255"></a>00255       printf(<span class="stringliteral">"value addr(0x%x) = 0x%x\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00256"></a>00256      }
<a name="l00257"></a>00257      <span class="keywordflow">else</span> <span class="keywordflow">if</span> (format == <span class="charliteral">'f'</span>) {
<a name="l00258"></a>00258       printf(<span class="stringliteral">"value addr(0x%x) = %f\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>,*(<span class="keywordtype">float</span>*)(&amp;val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>));
<a name="l00259"></a>00259      }
<a name="l00260"></a>00260      <span class="keywordflow">else</span> {
<a name="l00261"></a>00261       printf(<span class="stringliteral">"Error: invalid data type option (i,x,f)\n"</span>);
<a name="l00262"></a>00262       <span class="keywordflow">break</span>; 
<a name="l00263"></a>00263      }
<a name="l00264"></a>00264     }
<a name="l00265"></a>00265     
<a name="l00266"></a>00266      usleep(10000); 
<a name="l00267"></a>00267      <span class="keywordflow">break</span>;
<a name="l00268"></a>00268    }
<a name="l00269"></a>00269    
<a name="l00270"></a>00270   }
<a name="l00271"></a>00271   <span class="comment">//write data to PSC</span>
<a name="l00272"></a>00272   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'w'</span>) 
<a name="l00273"></a>00273   {
<a name="l00274"></a>00274    printf(<span class="stringliteral">"Writing ............. \n"</span>);
<a name="l00275"></a>00275    printf(<span class="stringliteral">"Please, give data to be sent to PS\n"</span>);
<a name="l00276"></a>00276    <span class="comment">//gets(data);</span>
<a name="l00277"></a>00277    <span class="comment">//cos = getchar();</span>
<a name="l00278"></a>00278    scanf(<span class="stringliteral">"%s"</span>, data);
<a name="l00279"></a>00279    cos=getchar();
<a name="l00280"></a>00280    printf(<span class="stringliteral">"Please, give the data format: \n i\t - for integer\n x \t - for hex \n f \t -for float \n"</span>);
<a name="l00281"></a>00281    scanf(<span class="stringliteral">"%c"</span>,&amp;format);
<a name="l00282"></a>00282    cos=getchar();
<a name="l00283"></a>00283    <span class="comment">//format = getchar();</span>
<a name="l00284"></a>00284    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);  
<a name="l00285"></a>00285    
<a name="l00286"></a>00286    <span class="comment">/*sscanf(argv[7], "%3x", &amp;tmp);</span>
<a name="l00287"></a>00287 <span class="comment">   val.stat = tmp;*/</span>
<a name="l00288"></a>00288    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0xc0; <span class="comment">/* writing status register */</span> 
<a name="l00289"></a>00289    sscanf(addr, <span class="stringliteral">"%2x"</span>, &amp;tmp);
<a name="l00290"></a>00290    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = tmp; 
<a name="l00291"></a>00291    <span class="comment">//val.address = 0x9C;</span>
<a name="l00292"></a>00292    
<a name="l00293"></a>00293    <span class="keywordflow">if</span> (format == <span class="charliteral">'i'</span>) 
<a name="l00294"></a>00294    {
<a name="l00295"></a>00295     val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = atoi(data);
<a name="l00296"></a>00296     printf(<span class="stringliteral">"given data: %d\n"</span>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00297"></a>00297    }
<a name="l00298"></a>00298    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (format == <span class="charliteral">'x'</span>) 
<a name="l00299"></a>00299    { 
<a name="l00300"></a>00300     sscanf(data, <span class="stringliteral">"%8x"</span>, &amp;tmp);
<a name="l00301"></a>00301     val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = tmp;
<a name="l00302"></a>00302     printf(<span class="stringliteral">"given data: %x\n"</span>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00303"></a>00303    }
<a name="l00304"></a>00304    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (format == <span class="charliteral">'f'</span>) 
<a name="l00305"></a>00305    {
<a name="l00306"></a>00306     ftmp = atof(data);
<a name="l00307"></a>00307     val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = *(<span class="keywordtype">int</span> *) (&amp;ftmp);
<a name="l00308"></a>00308     printf(<span class="stringliteral">"given data: %f\n"</span>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00309"></a>00309    }
<a name="l00310"></a>00310    <span class="keywordflow">else</span> 
<a name="l00311"></a>00311    {
<a name="l00312"></a>00312     printf(<span class="stringliteral">"Error: invalid data type option (i,x,f)\n"</span>);
<a name="l00313"></a>00313     <span class="comment">//break; </span>
<a name="l00314"></a>00314    }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316    <span class="keywordflow">if</span> (err = ioctl(fd,  <a class="code" href="pscip_8h.html#145abb0528d0562f2d3e9180d2d8bdd7">PSCIP_WRITE</a>, &amp;val)) 
<a name="l00317"></a>00317    { <span class="comment">/* PSCIP_WRITE , PSCIP_WRHIPRIO */</span>
<a name="l00318"></a>00318     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),-err-<a class="code" href="pscip_8h.html#b661b89922349e1f42117ae8518801b5">PSCIP_ERR_OFFSET</a>);
<a name="l00319"></a>00319     <span class="comment">//break;</span>
<a name="l00320"></a>00320    } 
<a name="l00321"></a>00321    usleep(10000); 
<a name="l00322"></a>00322       
<a name="l00323"></a>00323   }
<a name="l00324"></a>00324   <span class="comment">//write wave to PSC</span>
<a name="l00325"></a>00325   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'a'</span>) 
<a name="l00326"></a>00326   { 
<a name="l00327"></a>00327    printf(<span class="stringliteral">"Writing wave............. \n"</span>);
<a name="l00328"></a>00328    printf(<span class="stringliteral">"Please, give data to be sent to PS\n"</span>);
<a name="l00329"></a>00329    <span class="comment">//gets(data);</span>
<a name="l00330"></a>00330    <span class="comment">//cos = getchar();</span>
<a name="l00331"></a>00331    scanf(<span class="stringliteral">"%s"</span>, data);
<a name="l00332"></a>00332    cos=getchar();
<a name="l00333"></a>00333 
<a name="l00334"></a>00334    printf(<span class="stringliteral">"Please, give the data format: \n i\t - for integer\n x \t - for hex \n f \t -for float \n"</span>);
<a name="l00335"></a>00335    <span class="comment">//format = getchar();</span>
<a name="l00336"></a>00336    scanf(<span class="stringliteral">"%c"</span>,&amp;format);
<a name="l00337"></a>00337    cos=getchar();
<a name="l00338"></a>00338 
<a name="l00339"></a>00339    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);  
<a name="l00340"></a>00340    
<a name="l00341"></a>00341    <span class="comment">/*sscanf(argv[7], "%3x", &amp;tmp);</span>
<a name="l00342"></a>00342 <span class="comment">   val.stat = tmp;*/</span>
<a name="l00343"></a>00343 
<a name="l00344"></a>00344    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0xC0; <span class="comment">// writing status register </span>
<a name="l00345"></a>00345    sscanf(addr, <span class="stringliteral">"%2x"</span>, &amp;tmp);
<a name="l00346"></a>00346    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = tmp; 
<a name="l00347"></a>00347    <span class="comment">//val.address = 0x9C;</span>
<a name="l00348"></a>00348 
<a name="l00349"></a>00349    <span class="keywordflow">if</span> (format == <span class="charliteral">'i'</span>) 
<a name="l00350"></a>00350    {
<a name="l00351"></a>00351     val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = atoi(data);
<a name="l00352"></a>00352     printf(<span class="stringliteral">"given data: %d\n"</span>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00353"></a>00353    }
<a name="l00354"></a>00354    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (format == <span class="charliteral">'x'</span>) 
<a name="l00355"></a>00355    { 
<a name="l00356"></a>00356     sscanf(data, <span class="stringliteral">"%8x"</span>, &amp;tmp);
<a name="l00357"></a>00357     val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = tmp;
<a name="l00358"></a>00358     printf(<span class="stringliteral">"given data: %x\n"</span>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00359"></a>00359    }
<a name="l00360"></a>00360    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (format == <span class="charliteral">'f'</span>) 
<a name="l00361"></a>00361    {
<a name="l00362"></a>00362     ftmp = atof(data);
<a name="l00363"></a>00363     val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = *(<span class="keywordtype">int</span> *) (&amp;ftmp);
<a name="l00364"></a>00364     printf(<span class="stringliteral">"given data: %f\n"</span>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00365"></a>00365    }
<a name="l00366"></a>00366    <span class="keywordflow">else</span> 
<a name="l00367"></a>00367    {
<a name="l00368"></a>00368     printf(<span class="stringliteral">"Error: invalid data type option (i,x,f)\n"</span>);
<a name="l00369"></a>00369     <span class="comment">//break; </span>
<a name="l00370"></a>00370    }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372    <span class="keywordflow">if</span> (err = ioctl(fd,  <a class="code" href="pscip_8h.html#c644090d8b0ecb81e3fc1f37136fefcb">PSCIP_WRWAVE</a>, &amp;val)) { <span class="comment">/* PSCIP_WRITE , PSCIP_WRHIPRIO */</span>
<a name="l00373"></a>00373     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),-err-<a class="code" href="pscip_8h.html#b661b89922349e1f42117ae8518801b5">PSCIP_ERR_OFFSET</a>);
<a name="l00374"></a>00374     <span class="comment">//break;</span>
<a name="l00375"></a>00375    } 
<a name="l00376"></a>00376    usleep(100000); 
<a name="l00377"></a>00377       
<a name="l00378"></a>00378   }
<a name="l00379"></a>00379   <span class="comment">//write data to register in IP</span>
<a name="l00380"></a>00380   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'c'</span>) 
<a name="l00381"></a>00381   { 
<a name="l00382"></a>00382    printf(<span class="stringliteral">"Writing byte to address in IP............. \n"</span>);
<a name="l00383"></a>00383    printf(<span class="stringliteral">"Please, give data to be sent to PS\n"</span>);
<a name="l00384"></a>00384    <span class="comment">//gets(data);</span>
<a name="l00385"></a>00385    <span class="comment">//cos = getchar();</span>
<a name="l00386"></a>00386    scanf(<span class="stringliteral">"%s"</span>, data);
<a name="l00387"></a>00387    cos=getchar();
<a name="l00388"></a>00388  
<a name="l00389"></a>00389    sscanf(data, <span class="stringliteral">"%2x"</span>, &amp;tmp);
<a name="l00390"></a>00390    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = tmp;
<a name="l00391"></a>00391    printf(<span class="stringliteral">"given data: %x\n"</span>,val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a>);
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 
<a name="l00394"></a>00394    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);  
<a name="l00395"></a>00395    
<a name="l00396"></a>00396 
<a name="l00397"></a>00397    sscanf(addr, <span class="stringliteral">"%2x"</span>, &amp;tmp);
<a name="l00398"></a>00398    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = tmp; 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400    <span class="keywordflow">if</span> (err = ioctl(fd,  <a class="code" href="pscip_8h.html#835190a56c8493939498802b5bed4194">PSCIP_WRITEIPREG</a>, &amp;val)) { <span class="comment">/* PSCIP_WRITE , PSCIP_WRHIPRIO */</span>
<a name="l00401"></a>00401     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),-err-<a class="code" href="pscip_8h.html#b661b89922349e1f42117ae8518801b5">PSCIP_ERR_OFFSET</a>);
<a name="l00402"></a>00402     <span class="comment">//break;</span>
<a name="l00403"></a>00403    } 
<a name="l00404"></a>00404    usleep(100000); 
<a name="l00405"></a>00405       
<a name="l00406"></a>00406   }
<a name="l00407"></a>00407   <span class="comment">//read wave</span>
<a name="l00408"></a>00408   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'t'</span>) 
<a name="l00409"></a>00409   {
<a name="l00410"></a>00410    printf(<span class="stringliteral">"Reading wave............ \n"</span>);
<a name="l00411"></a>00411    
<a name="l00412"></a>00412 
<a name="l00413"></a>00413    printf(<span class="stringliteral">"Please, give the data format: \n i\t - for integer\n x \t - for hex \n f \t -for float \n"</span>);
<a name="l00414"></a>00414    <span class="comment">//format = getchar();</span>
<a name="l00415"></a>00415    scanf(<span class="stringliteral">"%c"</span>,&amp;format);
<a name="l00416"></a>00416    cos=getchar();
<a name="l00417"></a>00417    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);
<a name="l00418"></a>00418 
<a name="l00419"></a>00419    
<a name="l00420"></a>00420   
<a name="l00421"></a>00421    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x40; <span class="comment">/* reading status register */</span> 
<a name="l00422"></a>00422    sscanf(addr, <span class="stringliteral">"%2x"</span>, &amp;tmp);
<a name="l00423"></a>00423    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = tmp;
<a name="l00424"></a>00424    <span class="comment">//val.address = 0x9C;</span>
<a name="l00425"></a>00425   
<a name="l00426"></a>00426    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#f6891eb1f27034974efd79d30f27ed7a">PSCIP_RDWAVE</a>, &amp;val))) 
<a name="l00427"></a>00427    {
<a name="l00428"></a>00428     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00429"></a>00429     <span class="comment">//break;</span>
<a name="l00430"></a>00430    } 
<a name="l00431"></a>00431    <span class="keywordflow">else</span> 
<a name="l00432"></a>00432    {
<a name="l00433"></a>00433     <span class="keywordflow">if</span> (format == <span class="charliteral">'i'</span>) 
<a name="l00434"></a>00434     {
<a name="l00435"></a>00435      printf(<span class="stringliteral">"value addr(0x%x) = %d\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00436"></a>00436     }
<a name="l00437"></a>00437     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (format == <span class="charliteral">'x'</span>) 
<a name="l00438"></a>00438     { 
<a name="l00439"></a>00439      printf(<span class="stringliteral">"value addr(0x%x) = 0x%x\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00440"></a>00440     }
<a name="l00441"></a>00441     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (format == <span class="charliteral">'f'</span>) 
<a name="l00442"></a>00442     {
<a name="l00443"></a>00443      printf(<span class="stringliteral">"value addr(0x%x) = %f\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>,*(<span class="keywordtype">float</span>*)(&amp;val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>));
<a name="l00444"></a>00444     }
<a name="l00445"></a>00445     <span class="keywordflow">else</span> 
<a name="l00446"></a>00446     {
<a name="l00447"></a>00447      printf(<span class="stringliteral">"Error: invalid data type option (i,x,f)\n"</span>);
<a name="l00448"></a>00448      <span class="comment">//break; </span>
<a name="l00449"></a>00449     }
<a name="l00450"></a>00450    }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452    usleep(100000); 
<a name="l00453"></a>00453    
<a name="l00454"></a>00454   }
<a name="l00455"></a>00455   <span class="comment">//read IP register</span>
<a name="l00456"></a>00456   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'v'</span>) 
<a name="l00457"></a>00457   {
<a name="l00458"></a>00458    printf(<span class="stringliteral">"Reading IP register............ \n"</span>);
<a name="l00459"></a>00459    
<a name="l00460"></a>00460 
<a name="l00461"></a>00461    
<a name="l00462"></a>00462    format=<span class="charliteral">'x'</span>;
<a name="l00463"></a>00463   
<a name="l00464"></a>00464    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x40; <span class="comment">/* reading status register */</span> 
<a name="l00465"></a>00465    sscanf(addr, <span class="stringliteral">"%2x"</span>, &amp;tmp);
<a name="l00466"></a>00466    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = tmp;
<a name="l00467"></a>00467 
<a name="l00468"></a>00468   
<a name="l00469"></a>00469    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#734db0298305c99c5ed29f2881c08ee5">PSCIP_READIPREG</a>, &amp;val))) 
<a name="l00470"></a>00470    {
<a name="l00471"></a>00471     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00472"></a>00472     <span class="comment">//break;</span>
<a name="l00473"></a>00473    } 
<a name="l00474"></a>00474 
<a name="l00475"></a>00475    printf(<span class="stringliteral">"value addr(0x%x) = 0x%x\n"</span>,val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a>,val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a>);
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478  
<a name="l00479"></a>00479    
<a name="l00480"></a>00480   }
<a name="l00481"></a>00481   <span class="comment">// reset IP </span>
<a name="l00482"></a>00482   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'s'</span>) 
<a name="l00483"></a>00483   { 
<a name="l00484"></a>00484    printf(<span class="stringliteral">"Reseting IP........... \n"</span>);
<a name="l00485"></a>00485    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]); 
<a name="l00486"></a>00486    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#5788cb36fa2a76b191152affbce54791">PSCIP_RESET</a>))) 
<a name="l00487"></a>00487    {
<a name="l00488"></a>00488     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00489"></a>00489     <span class="comment">//break;</span>
<a name="l00490"></a>00490    } 
<a name="l00491"></a>00491   
<a name="l00492"></a>00492   }
<a name="l00493"></a>00493   <span class="comment">//reset FPGA error counter</span>
<a name="l00494"></a>00494   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'p'</span>) 
<a name="l00495"></a>00495   { 
<a name="l00496"></a>00496    printf(<span class="stringliteral">"Reseting IP........... \n"</span>);
<a name="l00497"></a>00497    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]); 
<a name="l00498"></a>00498    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#2a7c8b03e64b8001a8fab58b5912ef30">PSCIP_CLRCOUNTER</a>, &amp;val))) 
<a name="l00499"></a>00499    {
<a name="l00500"></a>00500     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00501"></a>00501     <span class="comment">//break;</span>
<a name="l00502"></a>00502    } 
<a name="l00503"></a>00503   
<a name="l00504"></a>00504   }
<a name="l00505"></a>00505   <span class="comment">//set current</span>
<a name="l00506"></a>00506   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'x'</span>) 
<a name="l00507"></a>00507   { 
<a name="l00508"></a>00508    printf(<span class="stringliteral">"Setting current ............. \n"</span>);
<a name="l00509"></a>00509    printf(<span class="stringliteral">"Please, give the current to be set \n"</span>);
<a name="l00510"></a>00510 
<a name="l00511"></a>00511    scanf(<span class="stringliteral">"%s"</span>, data);
<a name="l00512"></a>00512    cos=getchar();
<a name="l00513"></a>00513    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);  
<a name="l00514"></a>00514    
<a name="l00515"></a>00515    sscanf(addr, <span class="stringliteral">"%2x"</span>, &amp;tmp);
<a name="l00516"></a>00516    val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0xc0; <span class="comment">/* writing status register */</span> 
<a name="l00517"></a>00517    val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = tmp; 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519    
<a name="l00520"></a>00520    val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a> = atoi(data);
<a name="l00521"></a>00521    printf(<span class="stringliteral">"given data: %d\n"</span>,val.<a class="code" href="structpscip__t.html#d6ee430a30c9dc8e5ad006efcf5be07d">data</a>);
<a name="l00522"></a>00522    
<a name="l00523"></a>00523    <span class="keywordflow">if</span> (err = ioctl(fd,  <a class="code" href="pscip_8h.html#f564936bc290fbdda24a3f9ce25ea70d">PSCIP_WRHIPRIO</a>, &amp;val)) 
<a name="l00524"></a>00524    { <span class="comment">/* PSCIP_WRITE , PSCIP_WRHIPRIO */</span>
<a name="l00525"></a>00525     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),-err-<a class="code" href="pscip_8h.html#b661b89922349e1f42117ae8518801b5">PSCIP_ERR_OFFSET</a>);
<a name="l00526"></a>00526     <span class="comment">//break;</span>
<a name="l00527"></a>00527    } 
<a name="l00528"></a>00528    usleep(10000); 
<a name="l00529"></a>00529       
<a name="l00530"></a>00530   }
<a name="l00531"></a>00531   <span class="comment">//read PCI virtual base address and dump all the info if in DEBUG mode</span>
<a name="l00532"></a>00532   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == <span class="charliteral">'y'</span>) 
<a name="l00533"></a>00533   { 
<a name="l00534"></a>00534    printf(<span class="stringliteral">"Reading PCIaddres........... \n"</span>);
<a name="l00535"></a>00535    printf(<span class="stringliteral">"----------------------------------------------- N O T E -----------------------------------------\n"</span>); 
<a name="l00536"></a>00536    printf(<span class="stringliteral">"-----   if in DEBUG mode (#define DEGUG in pscip.c) this function read all registers    -----\n"</span>);
<a name="l00537"></a>00537    printf(<span class="stringliteral">"----- from the Carrier and IP and prints them to linux log file ($cat /var/log/messages) -----\n"</span>);
<a name="l00538"></a>00538    printf(<span class="stringliteral">"-------------------------------------------------------------------------------------------------\n"</span>);
<a name="l00539"></a>00539    
<a name="l00540"></a>00540    val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]); 
<a name="l00541"></a>00541    <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#b1756c28ed55fd46b27c1c9c9c79109a">PSCIP_PCIADDR</a>, &amp;pciaddr))) 
<a name="l00542"></a>00542    {
<a name="l00543"></a>00543     printf(<span class="stringliteral">"Ioctl error: %s, err_type=%d\n"</span>,<a class="code" href="test__prog_8c.html#4826b4785ca3a918667ec49b7f73affa">pscip_get_errmsg</a>(err),err);
<a name="l00544"></a>00544     <span class="comment">//break;</span>
<a name="l00545"></a>00545    } 
<a name="l00546"></a>00546    printf(<span class="stringliteral">"PCI Address: 0x%x\n"</span>, pciaddr);
<a name="l00547"></a>00547   }
<a name="l00548"></a>00548   
<a name="l00549"></a>00549   <span class="keywordflow">else</span> 
<a name="l00550"></a>00550   {
<a name="l00551"></a>00551    printf(<span class="stringliteral">"Error: invalid action type (r/w/a/t/x/s/q/y)\n"</span>);
<a name="l00552"></a>00552    <span class="comment">//return 0;</span>
<a name="l00553"></a>00553   }
<a name="l00554"></a>00554  }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556  close(fd);
<a name="l00557"></a>00557  <span class="keywordflow">return</span> 0;
<a name="l00558"></a>00558   
<a name="l00559"></a>00559 }
</pre></div></div>
<hr size="1"><address style="text-align: right;"><small>Generated on Fri Dec 5 17:49:43 2008 by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.7.1 </small></address>
</body>
</html>
